'--------------------------------------------------------------
'                   SSP > Stromschleifenprfgert
'
'  (C) Erich Linsmeier, Lindenstr. 1, 93483 Psing, Germany
'                   EMail  mail@dl2rcg.de
'--------------------------------------------------------------
'  File:       SSP.BAS           Version 1.00
'  first:      01.06.99
'  last:       22.06.99  17.07.99
'--------------------------------------------------------------


' Definitionen

$large                                                        ' wegen 4051 Sprungadressen knnen weiter auseinander liegen
'$noinit

'Config Lcdpin , Db4 = P1.5 , Db5 = P1.4 , Db6 = P1.3 , Db7 = P1.2 , E = P1.6 , Rs = P1.7

$crystal = 12000000                                           ' Quarzfrequenz 12 MHz

Config Lcd = 16 * 4                                           ' configure lcd
Config Lcdhigh                                                ' fr Tastenabfrage

Dim Bit_count As Byte                                         ' Bit-Zhler
Dim Time As Byte                                              ' Verzgerungszeit
Dim Time_del As Byte                                          ' umgerechnete Verzgerungszeit
Dim Temp2 As Byte
Dim Temp3 As Byte
Dim Iu_w As Word                                              ' Wert fr I oder U Wert
Dim Da_w As Word                                              ' zu wandelnder Wert
Dim I_min As Word                                             ' Variablen
Dim I_max As Word
Dim U_min As Word
Dim U_max As Word

Dim Min As Word                                               ' Automode-Variablen
Dim Max As Word                                               ' Automode-Variablen
Dim Temp1 As Word

Dim Modus As Bit                                              ' 1 = I-Mode, 0 = U-Mode
Dim Var As Bit                                                ' 1 = Step, 0 = linear
Dim Le_flag As Bit                                            ' 1 = Loop-Error aufgetreten, merken


' Vorgaben

Light Alias P3.0                                              ' Hintergrundbeleuchtung (L=EIN)
Buzzer Alias P3.7                                             ' Summer (L=EIN)
Rs1 Alias P1.1                                                ' Range Select 1
Rs2 Alias P1.0                                                ' Range Select 2
Low_bat Alias P3.1                                            ' Batterieprfung
Fault Alias P3.5                                              ' Loop Error

Clk Alias P3.3
Dat Alias P3.2
Le Alias P3.4

Key1 Alias P1.5                                               ' Key TA1
Key2 Alias P1.4                                               ' Key TA2
Key3 Alias P1.3                                               ' Key TA3
Key4 Alias P1.2                                               ' Key TA4

I_min = 400                                                   ' Vorbelegen der Automode-Werte
I_max = 2000
U_min = 100
U_max = 800

Time = 10                                                     ' Vorgabe Verzgerung AUTO-Mode

' Init

P3 = &B11100011                                               ' alle Pins am P3 HIGH

' Le = 0  bereits oben ausgefhrt !!
' Clk = 0
' Dat = 0
' Light = 1     = AUS



' Programmbeginn

Anfang:

Gosub Copyright                                               ' Ausgabe Copyright
Gosub Pieps

Wait 3

Cls
Cursor Off

' Hauptprogramm

Var = 0                                                       ' wird nach Init zu 0 umgeschaltet
Modus = 1                                                     ' am Anfang Strommodus
Le_flag = 1                                                   ' damit wird erster Loop-Error Pieps unterdrckt
Iu_w = I_min                                                  ' Vorbelegung bei PRG Start fr I-Mode
Gosub Iu_mode                                                 ' initialisere I-Mode
Gosub Variation                                               ' zeige Variationstyp im LCD

Main:

Fourthline
Lcd "Mod Lgh  Aut Prg"


Main_repeat:
Debounce Key1 , 0 , Sw_mode , Sub                             ' Modus umschalten

Debounce Key4 , 0 , Prog                                      ' programmiere Automode

Debounce Key3 , 0 , Auto                                      ' Aufruf Automode

Debounce Key2 , 0 , Light , Sub                               ' Licht Ein/Aus

Gosub Check_loop
Gosub Check_ub
Goto Main_repeat





Prog:

Fourthline
Lcd "Var  -    +  Ent"
Bitwait Key2 , Set

If Modus = 1 Then                                             ' Start-Wert holen
   Iu_w = I_min
Else
   Iu_w = U_min
End If
Gosub Iu_mode                                                 ' Daten aktualisieren


Prog2:                                                        ' Unterpr. fr MIN-Wert

Locate 2 , 8
Lcd "L"                                                       ' LOW-Wert eingeben

Rep_prog2:
If Key3 = 0 Then
   Gosub Plus
   Goto Rep_prog2                                             ' wiederhole
End If

If Key2 = 0 Then
   Gosub Minus
   Goto Rep_prog2                                             ' wiederhole
End If

Gosub Check_loop
Gosub Check_ub
Debounce Key1 , 0 , Variation , Sub                           ' schalte Lin - Swi um
Debounce Key4 , 0 , Prog31

If Modus = 1 Then                                             ' Wert abspeichern
   I_min = Iu_w
Else
   U_min = Iu_w
End If

Goto Prog2


Prog31:                                                       ' Unterpr. fr MAX-Wert

If Modus = 1 Then                                             ' Start-Wert holen
   Iu_w = I_max
Else
   Iu_w = U_max
End If
Gosub Iu_mode                                                 ' Werte aktualisieren


Prog3:                                                        ' Stelle Minimumwert ein

Locate 2 , 8
Lcd "H"                                                       ' HIGH-Wert eingeben

Rep_prog3:
If Key3 = 0 Then
   Gosub Plus
   Goto Rep_prog3                                             ' wiederhole
End If

If Key2 = 0 Then
   Gosub Minus
   Goto Rep_prog3                                             ' wiederhole
End If

Gosub Check_loop
Gosub Check_ub
Debounce Key1 , 0 , Variation , Sub                           ' schalte Lin - Swi um
Debounce Key4 , 0 , Prog_time                                 ' programmiere Verzgerungszeit
Goto Prog3                                                    ' wiederhole ohne LCD-Erneuerung


Prog_time:

If Var = 1 Then                                               ' wenn VAR = 1 dann Zeiteinstellung

Lowerline
Lcd "Delay:       s  "
Gosub Dis_time                                                ' aktuelle Zeit ausgeben

Prog_time1:

If Key3 = 0 Then
   Incr Time
   If Time = 31 Then                                          ' prfe Zeitgrenzen
      Time = 1
   End If
   Gosub Dis_time                                             ' zeige Zeit an
   Waitms 500
End If

If Key2 = 0 Then
   Decr Time
   If Time = 0 Then                                           ' prfe Zeitgrenzen
      Time = 30
   End If
   Gosub Dis_time                                             ' zeige Zeit an
   Waitms 500
End If


Debounce Key4 , 0 , Prog_end                                  ' beende Programmierung
Goto Prog_time1
End If


Prog_end:

If Modus = 1 Then                                             ' Wert abspeichern + niedrigen Startwert laden
   I_max = Iu_w
   Iu_w = I_min                                               ' niedrigen Startwert laden
Else
   U_max = Iu_w
   Iu_w = U_min                                               ' niedrigen Startwert laden
End If

If I_max < I_min Then                                         ' prfe falls max < min, dann Tausch
   Temp1 = I_max
   I_max = I_min
   I_min = Temp1
End If

If U_max < U_min Then                                         ' prfe falls max < min, dann Tausch
   Temp1 = U_max
   U_max = U_min
   U_min = Temp1
End If

Gosub Iu_mode                                                 ' Werte bernehmen

Goto Main




Dis_time:                                                     ' gibt Verzgerungszeit aus

Locate 2 , 11
If Time < 10 Then                                             ' formatiere Anzeige
   Lcd " " ; Time
Else
   Lcd Time
End If

Return




Plus:

Incr Iu_w                                                     ' erhhe Wert

If Modus = 1 Then                                             ' je nach Mode Grenzen prfen
   If Iu_w = 2400 Then
      Iu_w = 0
   End If
Else
   If Iu_w = 1000 Then
      Iu_w = 0
   End If
End If

Gosub Iu_mode                                                 ' Werte bergeben

If Key1 = 0 Then                                              ' erhhe Geschwindigkeit
   Return
End If

Waitms 100

Return



Minus:

If Modus = 1 Then                                             ' je nach Mode Grenzen prfen
   If Iu_w = 0 Then
      Iu_w = 2400
   End If
Else
   If Iu_w = 0 Then
      Iu_w = 1000
   End If
End If

Decr Iu_w                                                     ' erniedrige Wert
Gosub Iu_mode                                                 ' Werte bergeben

If Key1 = 0 Then                                              ' erhhe Geschwindigkeit
   Return
End If

Waitms 100

Return




Check_ub:

Locate 3 , 5
If Low_bat = 0 Then
   Lcd "Bat"
Else
   Lcd "   "
End If

Return




Variation:

Locate 3 , 1

If Var = 1 Then
   Var = 0
   Lcd "lin"
Else
   Var = 1
   Lcd "swi"
End If

Bitwait Key1 , Set                                            ' warte bis Taste gelst wird

Return



Auto:

Fourthline
Lcd "    Wai  Sto Lgh"

If Modus = 1 Then
   Min = I_min
   Max = I_max
Else
   Min = U_min
   Max = U_max
End If

Auto_rep:

If Var = 0 Then
   For Iu_w = Min To Max
Else
   Iu_w = Min
   Gosub Iu_mode                                              ' Werte ausgeben
   Gosub Time                                                 ' Verzgern
   Iu_w = Max
   Gosub Iu_mode                                              ' Werte ausgeben
   Gosub Time                                                 ' Verzgern
End If
Debounce Key4 , 0 , Light , Sub                               ' Licht Ein/Aus
Debounce Key3 , 0 , Main                                      ' Rcksprung zum Hauptmen

Gosub Check_loop
Bitwait Key2 , Set                                            ' halte an solange Taste gedrckt ist

If Var = 1 Then                                               ' wenn Auto-Umschaltmode, dann mit Goto zurck
   Goto Auto_rep
End If
   Gosub Iu_mode                                              ' Werte ausgeben, wenn Schleife AUTO
Next Iu_w

Goto Auto_rep                                                 ' wiederhole




Time:                                                         ' Unterprogramm wartet Variable Time ab

Temp2 = Time                                                  ' bergebe Verzgerungszeit
Incr Temp2

Rotate Temp2 , Left , 3                                       ' mal 8
Decr Temp2                                                    ' damit flieender bergang von 1 nach 15
For Time_del = Temp2 Downto 8                                 ' Zeitzhler

Gosub Check_loop                                              ' prfe Schleife alle 125ms mit

Waitms 125                                                    ' warte 125 ms


Locate 4 , 1                                                  ' Ausgabe der Restzeit
Temp3 = Time_del
clr c
Rotate Temp3 , Right                                          ' Wert fr Anzeige zurckrechnen
clr c
Rotate Temp3 , Right                                          ' Wert fr Anzeige zurckrechnen
clr c
Rotate Temp3 , Right                                          ' Wert fr Anzeige zurckrechnen

If Time_del < 80 Then                                         ' wenn kleiner Zeit*8, dann einstellige Zeit
   Lcd " " ; Temp3
Else
   Lcd Temp3
End If


Debounce Key3 , 0 , Main                                      ' Rcksprung zum Hauptmen, wenn Taste Stop
Bitwait Key2 , Set                                            ' halte an solange Taste gedrckt ist

Next Time_del

Return




Sw_mode:                                                      ' schalte Betriebsmodus um

If Modus = 1 Then
   Modus = 0
   Iu_w = U_min                                               ' Startwert fr U-Mode
Else
   Modus = 1
   Iu_w = I_min                                               ' Startwert fr I-Mode
End If

   Gosub Iu_mode                                              ' Werte bernehmen

Bitwait Key1 , Set                                            ' warte bis Taste gelst wird

Return





Light:

If Light = 1 Then
   Light = 0
Else
   Light = 1
End If
Bitwait Key4 , Set                                            ' warte bis Taste gelst wird

Return




Check_loop:

Locate 3 , 9

If Modus = 0 Then
   Lcd "         "
   Return
End If

Lcd "Loop "

If Fault = 0 Then
      If Le_flag = 0 Then
         Gosub Pieps                                          ' piepse 1 mal, da Loop-Error
      End If
   Le_flag = 1
   Lcd "Err"
Else
   Le_flag = 0
   Lcd "OK!"
End If


Return




Iu_mode:                                                      ' Routine fr Spannungs- u. Stromausgabe

Home

If Modus = 0 Then

   Lcd "U-Mode: (0-10 V)"
   Rs1 = 0                                                    ' Mode 0 - 10V
   Rs2 = 0

   Temp1 = 0                                                  ' lsche Temp1 Variable
   Da_w = Iu_w * 65                                           ' Grundwert errechnen
   Temp1 = Iu_w                                               ' Wert an DA_W Variable bergeben

   Rotate Temp1 , Right                                       ' berechne Korrektur (:2)
   Da_w = Da_w + Temp1                                        ' Wert an DA_W Variable bergeben
   Rotate Temp1 , Right , 4                                   ' berechne korrektur (:32) seit Anfang CALC
   Da_w = Da_w + Temp1                                        ' Wert an DA_W Variable bergeben

   Gosub Dis_wert                                             ' zeige Ausgabewert an und bertrage

   Lcd "0 mV"                                                 ' Einheit anzeigen

Else

   Lcd "I-Mode: (0-24mA)"
   Rs1 = 1                                                    ' Mode 0 - 24 mA
   Rs2 = 1

   Temp1 = 0                                                  ' lsche Temp1 Variable
   Da_w = Iu_w * 27                                           ' Grundwert errechnen
   Temp1 = Iu_w                                               ' Wert an DA_W Variable bergeben

   Rotate Temp1 , Right , 2                                   ' berechne Korrektur (:4)
   Da_w = Da_w + Temp1                                        ' Wert an DA_W Variable bergeben
   Rotate Temp1 , Right , 2                                   ' berechne korrektur (:32) seit Anfang CALC
   Da_w = Da_w + Temp1                                        ' Wert an DA_W Variable bergeben
   Rotate Temp1 , Right , 4                                   ' berechne korrektur (:256) seit Anfang CALC
   Da_w = Da_w + Temp1                                        ' Wert an DA_W Variable bergeben

   Gosub Dis_wert                                             ' zeige Ausgabewert an und bertrage

   Lcd "0 uA"                                                 ' Einheit anzeigen
End If

Gosub Send_byte
Gosub Latch_enable

Return




Dis_wert:                                                     ' zeigt Wert an

Lowerline
Lcd "Output:         "
Locate 2 , 9
Lcd Iu_w
Return



Copyright:

Cls                                                           ' lsche LCD
Cursor Off                                                    ' Cursor aus

Lcd " SS-PRUEFGERAET "
Lowerline
Lcd "   (C) DL2RCG   "
Thirdline
Lcd "Erich  Linsmeier"
Fourthline
Lcd " Software V1.00 "

Return










Send_byte:                                                    ' vorher in Temp1 zu Sendende Daten bergeben

For Bit_count = 0 To 15

If Da_w => &B1000000000000000 Then                            ' prfe, ob Bit High or Low
      Set Dat
   Else
      Reset Dat
End If

Gosub Clock_impuls                                            ' gib Clockimpuls aus
Rotate Da_w , Left

Next Bit_count
Return



Clock_impuls:

nop
nop
Clk = 1
nop
nop
nop
Clk = 0
nop
nop

Return



Latch_enable:                                                 ' Daten bernehmen

Le = 1
nop
Le = 0

Return




Pieps:

Buzzer = 0                                                    ' Summer EIN
Waitms 125                                                    ' warte 250 ms
Buzzer = 1                                                    ' Summer AUS

Return